﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WPFEdit.Document
{
    public interface IEditable
    {
        /// <summary>
        /// Gets or sets a vlue indicating if the document has changes or not
        /// </summary>
        bool Dirty { get; set; }
        /// <summary>
        /// Gets or sets a value indicating if the document is fully created or not.
        /// While the doucment is not loaded, semantically the Dirty value should not change since
        /// object's values are not acctually changing, they are being initialized.
        /// </summary>
        bool Loaded { get; set; }
        event ValueChangedEventHandler<bool> DirtyChanged;
    }
}
