﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using log4net;

namespace WPFEdit.Framework
{
	/// <summary>
	/// Centralized point to handle all error processing.
	/// </summary>
	public interface IErrorHandler
	{
		/// <summary>
		/// Handles an error.
		/// </summary>
		/// <param name="message">A message describing what catching code was trying to do.</param>
		/// <param name="ex">The error thrown</param>
		/// <param name="logger">Log4net logger of the reporting class.</param>
		void HandlerError(string message, Exception ex, ILog logger);
	}
}
